package com.ufida.bap.executor;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Properties;

import org.apache.commons.lang.StringUtils;

import com.ufida.bap.log.LoggerManager;
import com.ufida.bap.sqlManage.SqlManager;

/**
 * װѯ
 * 
 * @author chenfeic
 * 
 */
public class GenerateSql {
	private SqlSetting sqlSetting = null;

	private static final String SEPARATE = ";";

	public GenerateSql() {
		this("DBTest.properties");
	}

	public GenerateSql(String propPath) {
		generateSql(propPath);
	}

	/***
	 * ʼѯúͲѯ
	 * 
	 * @param propPath
	 *            ļ·
	 */
	private void generateSql(String propPath) {
		// ȡpropertyļ
		Properties prop = new Properties();
		String driverName = null;
		String conn_Url = null;
		String userName = null;
		String pwd = null;
		String querySql = null;
		List<String> sqlList = null;
		int userCount = 0;
		String str_count = null;
		String outputPath = null;
		int maxPoolSize = 0;
		int minPoolSize = 0;
		int initPoolSize = 0;
		int maxIdleTime = 0;

		int maxThreadPoolSize;
		int coreThreadPoolSize;
		int keepAliveTime;
		try {
			InputStream in = new FileInputStream(propPath);
			prop.load(in);
			driverName = prop.getProperty("Driver_Name").trim();
			conn_Url = prop.getProperty("Connection_URL").trim();
			userName = prop.getProperty("User_Name").trim();
			pwd = prop.getProperty("Password").trim();
			querySql = prop.getProperty("Query_Sql").trim();
			sqlList = spliList(querySql);

			str_count = prop.getProperty("User_Count").trim();
			outputPath = prop.getProperty("Output_Path").trim();
			maxPoolSize = Integer.parseInt(prop.getProperty("MaxPoolSize")
					.trim());
			minPoolSize = Integer.parseInt(prop.getProperty("MinPoolSize")
					.trim());
			initPoolSize = Integer.parseInt(prop.getProperty("InitialPoolSize")
					.trim());
			maxIdleTime = Integer.parseInt(prop.getProperty("MaxIdleTime")
					.trim());
			maxThreadPoolSize = Integer.parseInt(prop.getProperty(
					"MaxThreadPoolSize").trim());
			coreThreadPoolSize = Integer.parseInt(prop.getProperty(
					"CoreThreadPoolSize").trim());
			keepAliveTime = Integer.parseInt(prop.getProperty("KeepAliveTime")
					.trim());

		} catch (FileNotFoundException e1) {
			LoggerManager.getInstance().getLogger().info("ûҵԴļ", e1);
			return;

		} catch (IOException e2) {
			LoggerManager.getInstance().getLogger().info("Դļس", e2);
			return;
		}
		boolean error = false;
		try {
			userCount = Integer.parseInt(str_count);
			if (userCount <= 0) {
				error = true;
			}
		} catch (NumberFormatException e1) {
			error = true;
		}
		if (error) {
			LoggerManager.getInstance().getLogger().error("ȷûΪ");
			return;
		}
		getSqlSetting().setDriverName(driverName);
		getSqlSetting().setConnUrl(conn_Url);
		getSqlSetting().setUserName(userName);
		getSqlSetting().setPassword(pwd);
		getSqlSetting().setQuerySql(sqlList);

		getSqlSetting().setUserCount(userCount);
		getSqlSetting().setMaxPoolSize(maxPoolSize);
		getSqlSetting().setMinPoolSize(minPoolSize);
		getSqlSetting().setInitPoolSize(initPoolSize);
		getSqlSetting().setMaxIdleTime(maxIdleTime);
		getSqlSetting().setOutputPath(outputPath);
		
		getSqlSetting().setMaxThreadPoolSize(maxThreadPoolSize);
		getSqlSetting().setCoreThreadPoolSize(coreThreadPoolSize);
		getSqlSetting().setKeepAliveTime(keepAliveTime);

	}

	/**
	 * ļеsqlзָ ûκsql䣬ѡ22Ĭ䡣
	 * 
	 * @param querySql
	 * @return
	 */
	private List<String> spliList(String querySql) {
		if (StringUtils.isEmpty(querySql)) {
			// صsqlѯı
			return SqlManager.getInstance().getAllSqlNum();
		}
		String[] sqls = querySql.split(SEPARATE);
		List<String> sqlList = new ArrayList<String>();
		for (String sql : sqls) {
			sqlList.add(sql);
		}
		return sqlList;
	}

	public SqlSetting getSqlSetting() {
		if (sqlSetting == null) {
			sqlSetting = new SqlSetting();
		}
		return sqlSetting;
	}

}
