package com.ufida.bap.utils;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;


/**
 * ȡļ
 * 
 * ļһkeyӦvalueȡ
 * 
 * @author chenfeic
 * 
 */
public class ConfFileReader {

	/** ¼key-valueֵ */
	private Map<String, Object> paramMap = new HashMap<String, Object>();

	/** ʽĬϰUTF-8ȡ */
	private String charset = "UTF-8";

	public ConfFileReader(String conf_FileName) {
		loadFromFile(conf_FileName);
	}

	public ConfFileReader(String conf_FileName, String charset) {
		this.charset = charset;
		loadFromFile(conf_FileName);
	}

	public String getStrValue(String name) {
		Object obj;
		obj = paramMap.get(name);
		if (obj == null) {
			return null;
		}

		if (obj instanceof String) {
			return (String) obj;
		}
		return (String) ((ArrayList<String>) obj).get(0);
	}

	public int getIntValue(String name, int default_value) {
		String szValue = this.getStrValue(name);
		if (szValue == null) {
			return default_value;
		}

		return Integer.parseInt(szValue);
	}

	public boolean getBoolValue(String name, boolean default_value) {
		String szValue = this.getStrValue(name);
		if (szValue == null) {
			return default_value;
		}

		return szValue.equalsIgnoreCase("yes")
				|| szValue.equalsIgnoreCase("on")
				|| szValue.equalsIgnoreCase("true") || szValue.equals("1");
	}

	public String[] getValues(String name) {
		Object obj;
		String[] values;

		obj = paramMap.get(name);
		if (obj == null) {
			return null;
		}

		if (obj instanceof String) {
			values = new String[1];
			values[0] = (String) obj;
			return values;
		}

		Object[] objs = ((ArrayList<String>) obj).toArray();
		values = new String[objs.length];
		System.arraycopy(objs, 0, values, 0, objs.length);
		return values;
	}

	private void loadFromFile(String conf_filename) {
		Reader fReader = null;
		BufferedReader buffReader = null;
		String line;
		String[] parts;
		String name;
		String value;
		Object obj;
		ArrayList<String> valueList;
		try {
			fReader = new InputStreamReader(new FileInputStream(conf_filename),
					charset);
			buffReader = new BufferedReader(fReader);
			while ((line = buffReader.readLine()) != null) {
				line = line.trim();
				if (line.length() == 0 || line.charAt(0) == '#') {
					continue;
				}

				parts = line.split("=", 2);
				if (parts.length != 2) {
					continue;
				}

				name = parts[0].trim();
				value = parts[1].trim();

				obj = paramMap.get(name);
				if (obj == null) {
					paramMap.put(name, value);
				} else if (obj instanceof String) {
					valueList = new ArrayList<String>();
					valueList.add((String) obj);
					valueList.add(value);
					paramMap.put(name, valueList);
				} else {
					valueList = (ArrayList<String>) obj;
					valueList.add(value);
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
//			AppDebug.error(e);
		} finally {
			closeReader(buffReader);
		}
	}

	private void closeReader(Reader reader) {
		if (reader != null) {
			try {
				reader.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
}
