package com.ufida.bap.utils;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;
import java.util.HashMap;
import java.util.Map;


/**
 * ޸ļܽڶͬkeyֵļ޸ ֤޸ĺļ˳򲻱䣬ܱעͲ
 * 
 * ʱ֧޸ģԿ
 * 
 * @author chenfeic
 * 
 */
public class ConfFileWriter {
	/** keyֵֵĴ */
	private Map<String, Integer> keyCountMap = new HashMap<String, Integer>();

	private String conf_FileName;

	/** ʽ */
	private String charset = "UTF-8";

	public ConfFileWriter(String conf_FileName) {
		this.conf_FileName = conf_FileName;
		loadFromFile(conf_FileName);
	}

	public ConfFileWriter(String conf_FileName, String charset) {
		this.conf_FileName = conf_FileName;
		this.charset = charset;
		loadFromFile(conf_FileName);
	}

	/**
	 * ļ
	 * 
	 * ˼·жļ¼ÿϢ뵱ǰkeyֵԵȲ鿴ֵĴִһΣȲ
	 * ִ1ΣֱΪ1ʱٴ
	 * 
	 * @param key
	 *            Ҫµ
	 * @param value
	 *            ºֵֵΪʱkeyֵͬļ¼
	 */
	public boolean updateConFile(String key, String[] value) {
		File file = new File(conf_FileName);
		boolean res = false;
		if (file.exists()) {
			Reader fReader = null;
			BufferedReader buffReader = null;
			OutputStream out = null;
			BufferedWriter writer = null;
			try {
				fReader = new InputStreamReader(new FileInputStream(file),
						charset);
				buffReader = new BufferedReader(fReader);
				String outstr = "";
				String line = "";
				while ((line = buffReader.readLine()) != null) {
					line = line.trim();
					if (line.length() == 0) // Ϊ
					{
						outstr += "\n";
						continue;
					}
					if (line.charAt(0) == '#') // Ϊע
					{
						outstr += (line + "\n");
						continue;
					}
					if (line.trim().startsWith(key)) {
						int count = keyCountMap.get(key);
						if (count != 1) {
							count--;
							keyCountMap.put(key, count);
							continue;
						}

						String[] keyandvalue = line.split("=");
						if (value == null || value.length == 0) {
							outstr += (keyandvalue[0].toString() + "=" + "" + "\n");
						} else {
							for (int i = 0; i < value.length; i++) {
								outstr += (keyandvalue[0].toString() + "="
										+ value[i] + "\n");
							}
						}
						res = true;
						continue;
					}
					outstr += line + "\n";
				}
				if (res) {
					out = new FileOutputStream(file, false);
					writer = new BufferedWriter(new OutputStreamWriter(out,
							charset));
					writer.write(outstr);
					return true;
				}

			} catch (Exception e) {
				e.printStackTrace();
//				AppDebug.error(e);
			} finally {
				closeWriter(writer);
				closeReader(buffReader);
			}
		}
		return false;
	}

	/**
	 * ļ¼ļиֵĴ
	 * 
	 * @param conf_filename
	 */
	private void loadFromFile(String conf_filename) {
		Reader fReader = null;
		BufferedReader buffReader = null;
		String line;
		String[] parts;
		String key;
		Integer obj;
		try {
			fReader = new InputStreamReader(new FileInputStream(conf_filename),
					charset);
			buffReader = new BufferedReader(fReader);
			while ((line = buffReader.readLine()) != null) {
				line = line.trim();
				if (line.length() == 0 || line.charAt(0) == '#') {
					continue;
				}

				parts = line.split("=", 2);
				if (parts.length != 2) {
					continue;
				}
				key = parts[0].trim();

				obj = keyCountMap.get(key);
				if (obj == null) {
					obj = 0;
				}
				obj++;//
				keyCountMap.put(key, obj);// ¼keyֵĴ
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			closeReader(buffReader);
		}
	}

	private void closeReader(Reader reader) {
		if (reader != null) {
			try {
				reader.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	private void closeWriter(Writer writer) {
		if (writer != null) {
			try {
				writer.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

}
